<?php

namespace Lean\Console\Entity\Firewall;

use Ulmus\Attribute\Obj\Table;
use Ulmus\Attribute\Property\Field;
use Ulmus\Entity\Field\Datetime;

#[Table(name:"firewall_banned_ips", adapter: "lean.console")]
class BannedIp implements \JsonSerializable
{
    use \Ulmus\EntityTrait;

    #[Field\Id]
    public string $id;

    #[Field\ForeignKey(name: "connection_id")]
    public ? int $connectionId;

    #[Field(length: 12)]
    public ? string $ipv4;

    #[Field(length: 40)]
    public ? string $ipv6;

    #[Field\Datetime(name: "banned_until")]
    public Datetime $bannedUntil;

    #[Field\Datetime(name: "created_at")]
    public Datetime $createdAt;
}